#! /usr/bin/ruby
#= 3DSMetasequoiaϊXNvg

require '3ds'
$Scaling = 1.0

module Model3DS
   class Vertex < MetaRed::Vector
      def to_s
         "#{@x*$Scaling} #{@y*$Scaling} #{@z*$Scaling}"
      end
   end
end

#= PƂŌĂяoꂽꍇ̂ݗLȏB
# CuƂČĂяoꂽꍇɂ͖B
if $0 == __FILE__
   require 'optparse'
   ARGV.options{|opts|
      opts.banner = "Usage: #{$0} [options] 3ds_file ...\n"

      opts.on_head("normal options:")

      opts.on("--scaling=SCALING", Float, ":float [1.0]") {|$Scaling|}

      opts.on_tail # separater
      opts.on_tail("common options:")
      opts.on_tail("-?", "--help", "show this message") {puts opts; exit}
      opts.parse!
   } or (puts "\n", ARGV.options; exit 1)

   ARGV.reject!{|x|
      !(/\.3ds$/i =~ x)
   }
   (puts ARGV.options; exit) if ARGV.empty?
   ARGV.options = nil	# no more parse

   ARGV.each{|fn|
      Model3DS.load(fn).save_as_mqo(fn.gsub(/\.3ds$/i,'.mqo'))
   }
end
